
#property copyright "AtApi"
#property link      "dumpinto@gmail.com"
//----
string Indicator_Name = "GeoRoc";
int Objs = 0;
//----
#property indicator_separate_window
#property indicator_buffers 8
extern int ROC = 13;
extern bool USD = FALSE;
extern bool EUR = FALSE;
extern bool GBP = FALSE;
extern bool CHF = FALSE;
extern bool JPY = FALSE;
extern bool AUD = FALSE;
extern bool CAD = FALSE;
extern bool NZD = FALSE;
extern color Color_USD = Green;
extern color Color_EUR = DarkBlue;
extern color Color_GBP = Red;
extern color Color_CHF = Chocolate;
extern color Color_JPY = Maroon;
extern color Color_AUD = DarkOrange;
extern color Color_CAD = Purple;
extern color Color_NZD = Teal;
extern int Line_Thickness = 2;
extern int BarsBack = 0;
//----
//----Global Variables
string EuroPairs[] = {"EURUSD","EURGBP","EURAUD","EURNZD","EURCHF","EURCAD","EURJPY"};
string USDPairs[] = {"USDCHF","USDCAD","USDJPY","NZDUSD","EURUSD","GBPUSD","AUDUSD"};
string GBPPairs[] = {"GBPUSD","GBPCHF","GBPCAD","GBPAUD","GBPJPY","GBPNZD","EURGBP"};
string AUDPairs[] = {"AUDUSD","AUDCHF","AUDCAD","AUDNZD","AUDJPY","EURAUD","GBPAUD"};
string CHFPairs[] = {"NZDCHF","AUDCHF","CADCHF","EURCHF","USDCHF","GBPCHF","CHFJPY"};
string NZDPairs[] = {"NZDCHF","NZDUSD","NZDCAD","NZDJPY","AUDNZD","EURNZD","GBPNZD"};
string CADPairs[] = {"CADCHF","CADJPY","NZDCAD","AUDCAD","EURCAD","GBPCAD","USDCAD"};
string JPYPairs[] = {"NZDJPY","GBPJPY","AUDJPY","USDJPY","CHFJPY","EURJPY","CADJPY"};


double arrUSD[];
double arrEUR[];
double arrGBP[];
double arrCHF[];
double arrJPY[];
double arrAUD[];
double arrCAD[];
double arrNZD[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(USD)
       Indicator_Name = StringConcatenate(Indicator_Name, " USD");
   if(EUR)
       Indicator_Name = StringConcatenate(Indicator_Name, " EUR");
   if(GBP)
       Indicator_Name = StringConcatenate(Indicator_Name, " GBP");
   if(CHF)
       Indicator_Name = StringConcatenate(Indicator_Name, " CHF");
   if(AUD)
       Indicator_Name = StringConcatenate(Indicator_Name, " AUD");
   if(CAD)
       Indicator_Name = StringConcatenate(Indicator_Name, " CAD");
   if(JPY)
       Indicator_Name = StringConcatenate(Indicator_Name, " JPY");
   if(NZD)
       Indicator_Name = StringConcatenate(Indicator_Name, " NZD");
   IndicatorShortName(Indicator_Name);
   int cur = 0; 
   int st = 23; 
   if(USD)
     {
       sl("~", cur, Color_USD);
       cur += st;
     }
   if(EUR)
     {
       sl("~", cur, Color_EUR);
       cur += st;
     }
   if(GBP)
     {
       sl("~", cur, Color_GBP);
       cur += st;
     }
   if(CHF)
     {
       sl("~", cur, Color_CHF);
       cur += st;
     }
   if(AUD)
     {
       sl("~", cur, Color_AUD);
       cur += st;
     }
   if(CAD)
     {
       sl("~", cur, Color_CAD);
       cur += st;
     }
   if(JPY)
     {
       sl("~", cur, Color_JPY);
       cur += st;
     }
   if(NZD)
     {
       sl("~", cur, Color_NZD);
       cur += st;
     }


   SetIndexStyle(0, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_USD);
   SetIndexBuffer(0, arrUSD);
   SetIndexLabel(0, "USD"); 
   SetIndexStyle(1, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_EUR);
   SetIndexBuffer(1, arrEUR);
   SetIndexLabel(1, "EUR"); 
   SetIndexStyle(2, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_GBP);
   SetIndexBuffer(2, arrGBP);
   SetIndexLabel(2, "GBP"); 
   SetIndexStyle(3, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_CHF);
   SetIndexBuffer(3, arrCHF);
   SetIndexLabel(3, "CHF"); 
   SetIndexStyle(4, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_JPY);
   SetIndexBuffer(4, arrJPY);
   SetIndexLabel(4, "JPY"); 
   SetIndexStyle(5, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_AUD);
   SetIndexBuffer(5, arrAUD);
   SetIndexLabel(5, "AUD"); 
   SetIndexStyle(6, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_CAD);
   SetIndexBuffer(6, arrCAD);
   SetIndexLabel(6, "CAD"); 
   SetIndexStyle(7, DRAW_LINE, DRAW_LINE, Line_Thickness, Color_NZD);
   SetIndexBuffer(7, arrNZD);
   SetIndexLabel(7, "NZD"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = 0; i < Objs; i++)
     {
      if(!ObjectDelete(Indicator_Name + i))
          Print("error: code #", GetLastError());
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i,counted_bars = IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
     for(i = limit; i >= 0 ; i--)
               {
       
       if(EUR)
         {
           double RawData = 1; 
           for (int Curr = 0; Curr <7; Curr++)
            {
               RawData = RawData *  iClose(EuroPairs[Curr],0,i);
            }
            
            arrEUR[i] = MathPow(RawData,0.15);
              
         }
         
       if(GBP)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (Curr < 6) RawData = RawData * iClose(GBPPairs[Curr],0,i); else if (Curr > 6 && 1/iClose(GBPPairs[Curr],0,i) != 0) RawData = RawData * (1/iClose(GBPPairs[Curr],0,i)); 
            }
            arrGBP[i] = MathPow(RawData,0.15);

         }
       if(AUD)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (Curr < 5) RawData = RawData * iClose(AUDPairs[Curr],0,i); else if (Curr > 5 && 1/iClose(AUDPairs[Curr],0,i) != 0)  RawData = RawData * (1/iClose(AUDPairs[Curr],0,i));  
            }
            arrAUD[i] = MathPow(RawData,0.15);

         }
       if(NZD)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (Curr < 4) RawData = RawData * iClose(NZDPairs[Curr],0,i); else if (Curr > 4 && 1/iClose(NZDPairs[Curr],0,i) != 0) RawData = RawData * (1/iClose(NZDPairs[Curr],0,i)); 
            }
            arrNZD[i] = MathPow(RawData,0.15);

         }
       if(CAD)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (Curr < 2) RawData = RawData * iClose(CADPairs[Curr],0,i); else if (Curr > 2 && 1/iClose(CADPairs[Curr],0,i) != 0) RawData = RawData * (1/iClose(CADPairs[Curr],0,i));
            }
            arrCAD[i] = MathPow(RawData,0.15);
         }
       if(CHF)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (Curr < 6) RawData = RawData * iClose(CHFPairs[Curr],0,i); else if (Curr > 6 && 1/iClose(CHFPairs[Curr],0,i) != 0) RawData = RawData * (1/iClose(CHFPairs[Curr],0,i));
            }
            arrCHF[i] = MathPow(RawData,0.15);
         }
       if(JPY)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (1/iClose(JPYPairs[Curr],0,i) != 0) RawData = RawData * (1/iClose(JPYPairs[Curr],0,i));
            }
            arrJPY[i] = MathPow(RawData,0.15);
         }
        if(USD)
         {
           RawData = 1; 
           for (Curr = 0; Curr <7; Curr++)
            {
               if (Curr < 3) RawData = RawData * iClose(USDPairs[Curr],0,i); else if (Curr > 3 && 1/iClose(USDPairs[Curr],0,i) != 0) RawData = RawData * (1/iClose(USDPairs[Curr],0,i));
               
            }
            arrUSD[i] = MathPow(RawData,0.15);
         }

      }
      
      
  for(i=0;i<=limit;i++)
     {
     
       
       if(EUR)
         {
             arrEUR[i] = 100* ((arrEUR[i] - arrEUR[i+ROC]) / arrEUR[i+ROC]);
              
         }
         
       if(GBP)
         {
             arrGBP[i] = 100* ((arrGBP[i] - arrGBP[i+ROC]) / arrGBP[i+ROC]);   

         }
       if(AUD)
         {
             arrAUD[i] = 100* ((arrAUD[i] - arrAUD[i+ROC]) / arrAUD[i+ROC]);   

         }
       if(NZD)
         {
             arrNZD[i] = 100* ((arrNZD[i] - arrNZD[i+ROC]) / arrNZD[i+ROC]);   

         }
       if(CAD)
         {
             arrCAD[i] = 100* ((arrCAD[i] - arrCAD[i+ROC]) / arrCAD[i+ROC]);   
         }
       if(CHF)
         {
             arrCHF[i] = 100* ((arrCHF[i] - arrCHF[i+ROC]) / arrCHF[i+ROC]);   
         }
       if(JPY)
         {
             arrJPY[i] = 100* ((arrJPY[i] - arrJPY[i+ROC]) / arrJPY[i+ROC]);   
         }
        if(USD)
         {
             arrUSD[i] = 100* ((arrUSD[i] - arrUSD[i+ROC]) / arrUSD[i+ROC]);  
             
         }

      }
      
      
      
      
      
      
      
      
      
      
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sl(string sym, int y, color col)
  {
   int window = WindowFind(Indicator_Name);
   string ID = Indicator_Name+Objs;
   int tmp = 10 + y;
   Objs++;
   if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
     {
       //ObjectSet(ID, OBJPROP_CORNER, 1);
       ObjectSet(ID, OBJPROP_XDISTANCE, y + 35);
       ObjectSet(ID, OBJPROP_YDISTANCE, 0);
       ObjectSetText(ID, sym, 18, "Arial Black", col);
     }
  }   
//+------------------------------------------------------------------+

